'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.FRAG_TYPES = exports.RepType = exports.Fragment = exports.Reputation = exports.Reputable = undefined;

var _eos = require('./services/eos');

var eos = _interopRequireWildcard(_eos);

var _identity = require('./services/identity');

var _identity2 = _interopRequireDefault(_identity);

var _reputation = require('./services/reputation');

var _reputation2 = _interopRequireDefault(_reputation);

var _bond = require('./services/bond');

var _bond2 = _interopRequireDefault(_bond);

var _Reputable = require('./models/Reputable');

var _Reputable2 = _interopRequireDefault(_Reputable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

const FRAG_TYPES = {
    BLOCKCHAIN_ADDR: 'acc',
    ACTION: 'act',
    APPLICATION: 'app',
    IDENTITY: 'id',
    OTHER: 'etc'
};

exports.Reputable = _Reputable2.default;
exports.Reputation = _Reputable.Reputation;
exports.Fragment = _Reputable.Fragment;
exports.RepType = _Reputable.RepType;
exports.FRAG_TYPES = FRAG_TYPES;


class RIDL {

    constructor() {
        this.identity = new _identity2.default();
        this.reputation = new _reputation2.default();
        this.bond = new _bond2.default();
    }

    /***
     * Initializes RIDL for a specified account. Can be re-initialized as
     * many times as needed.
     * -------------------------------
     * Can be initialized as a reader only by passing nulls into the
     * account and signProvider parameters.
     * @param network
     * @param account
     * @param signProvider
     * @returns {Promise}
     */
    init(network, account = null, signProvider = null) {
        return eos.init(network, account, signProvider);
    }

    canConnect() {
        return eos.canConnect();
    }

}

exports.default = new RIDL();