"use strict";

Object.defineProperty(exports, "__esModule", {
				value: true
});

var _eos = require("./eos");

var eos = _interopRequireWildcard(_eos);

var _Bond = require("../models/Bond");

var _Bond2 = _interopRequireDefault(_Bond);

var _helpers = require("../util/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

class BondService {

				constructor() {}

				get(bond_id) {
								return _asyncToGenerator(function* () {
												return yield eos.read({
																table: 'bonds',
																index: bond_id,
																limit: 1,
																model: _Bond2.default,
																firstOnly: true
												});
								})();
				}

				findByFingerprint(title, details, username, limit, fixed_party) {
								return _asyncToGenerator(function* () {
												return yield eos.read({
																table: 'bonds',
																key_type: 'i64',
																index_position: 3,
																index: (0, _helpers.fingerprinted)(title + details + username + limit + fixed_party),
																nobound: true,
																limit: 1,
																model: _Bond2.default,
																firstOnly: true
												});
								})();
				}

				findBonds(identity_id) {
								return _asyncToGenerator(function* () {
												return yield eos.read({
																table: 'bonds',
																key_type: 'i64',
																index_position: 2,
																index: identity_id,
																limit: 500,
																model: _Bond2.default,
																rowsOnly: true
												});
								})();
				}

				createbond(username, title, details, duration, limit, starts_in_seconds = 0, fixed_party = 0) {
								var _this = this;

								return _asyncToGenerator(function* () {
												return eos.contract.createbond(username, title, details, duration, starts_in_seconds, limit, fixed_party, eos.options).then(function () {
																return _this.findByFingerprint(title, details, username, limit, fixed_party);
												});
								})();
				}

				disputebond(username, bond_id, rep = '1.0000 REP') {
								return _asyncToGenerator(function* () {
												return eos.contract.disputebond(username, bond_id, rep, eos.options);
								})();
				}

				cancelbond(username, bond_id) {
								return _asyncToGenerator(function* () {
												return eos.contract.cancelbond(username, bond_id, eos.options);
								})();
				}

				closebond(bond_id) {
								return _asyncToGenerator(function* () {
												return eos.contract.closebond(bond_id, eos.options);
								})();
				}

				erasebond(bond_id) {
								return _asyncToGenerator(function* () {
												return eos.contract.erasebond(bond_id, eos.options);
								})();
				}
}
exports.default = BondService;